/**
 * Created by AlexanderC on 6/12/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InvalidArnException = undefined;

var _Exception = require('../../../Exception/Exception');

/**
 * Thrown when ARN is invalid
 */
class InvalidArnException extends _Exception.Exception {
  /**
   * @param {String} arn
   */
  constructor(arn) {
    super(`Invalid arn string "${arn}".`);
  }
}
exports.InvalidArnException = InvalidArnException;