/**
 * Created by mgoria on 10/31/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InvalidCognitoIdentityException = undefined;

var _Exception = require('../../../Exception/Exception');

/**
 * Thrown when context identity pool id does not much identity pool id from security service
 */
class InvalidCognitoIdentityException extends _Exception.Exception {
  /**
   * @param {String} identityPoolId
   */
  constructor(identityPoolId) {
    super(`Invalid cognito identity pool "${identityPoolId}".`, 403);
  }
}
exports.InvalidCognitoIdentityException = InvalidCognitoIdentityException;