/**
 * Created by AlexanderC on 6/12/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MissingRuntimeContextException = undefined;

var _Exception = require('../../../Exception/Exception');

/**
 * Thrown when missing runtime lambda context
 */
class MissingRuntimeContextException extends _Exception.Exception {
  constructor() {
    super('Missing Lambda runtime context', 400);
  }
}
exports.MissingRuntimeContextException = MissingRuntimeContextException;