'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DatabaseOperationException = undefined;

var _Exception = require('./Exception');

/**
 * Thrown when operation on the database failed
 */
class DatabaseOperationException extends _Exception.Exception {

  /**
   * @param {String} error
   */
  constructor(error) {
    super(`Database operation failed. ${error}`, 500);
  }
}
exports.DatabaseOperationException = DatabaseOperationException;